/* 	USDP Sample code
	Program for Access Control System
	Port 0-0 is used for Password OK
	Port 0-1 is used for Password error
	Port 0-2 is used for system ready
	Port 1-0 is used for LCDRS
	Port 1-1 is used for LCDEN
	Port 2 is used for LCD data
*/

typedef unsigned char Uchar ;
typedef unsigned int  Uint ;
typedef unsigned long Ulong ;
typedef unsigned char uchar ;
typedef unsigned int  uint ;
typedef unsigned long ulong ;
#include <reg51.h>
#include <intrins.h>
//#include <lcd_routine.c>

#define   TR0_RELOAD (-921)
#define   TR1_RELOAD (-921)

sbit  LRS		=   P2 ^ 4 ;
sbit  LEN		=   P2 ^ 5 ;

Uint  count;

Uchar digit,once;

sbit  ok		=   P2 ^ 0 ;
sbit  err		=   P2 ^ 1 ;
sbit  ready		=   P2 ^ 2 ;

Uint  count;
Uchar digit;


Uchar digit;
void delay(Uint n)
{
	n = count + n;
   while (n != count);
}
void write_lcd(void)
{	
	
        LEN=1;
 		delay(6);
		LEN=0;
		
}

void execute_lcd(void)
{	   
		LRS=0; 		                    // command
		LEN=1;
		delay(6);
		LEN=0; 		
        LRS=1; 		
}   
void dispstr(Uchar *str,Uint stcol, Uint encol)
{
	if(stcol <= 15)
		P0 = 0x80;
	else
	{
		stcol = stcol-16;
		encol = encol-16;
		P0 = 0x0c0;
	}
 		execute_lcd();
		for(;stcol<=encol;stcol++)
	  {
	    P0 = str[stcol];
		write_lcd();
	  }
}

void clrlcd()
{

	P0 = 0x01;
	execute_lcd();
}



// LCD intialization
void initlcd(void)
{
		P0=0x38;
 		execute_lcd();
		P0=0x38;
		execute_lcd();
		P0=0x38;
		execute_lcd();
		P0=0x80;
 		execute_lcd();
		P0=0x80;
		execute_lcd();
		P0=0x80;
		execute_lcd();
		P0=0x01;
		execute_lcd();
		P0=0x01;
		execute_lcd();
		P0=0x06;
		execute_lcd();
		P0=0x06;
		execute_lcd();
		P0=0x0c;
		execute_lcd();
		P0=0x0c;
		execute_lcd();
		P0=0x0c;
	}






void timer0(void)
interrupt 1 using 1
{
  	count++;
	TH0 = (Uchar)(TR0_RELOAD>>8);
	TL0 = (Uchar)TR0_RELOAD;				 // reload
}


void io_open(void)
{
	TMOD = 0x01;
	TR0 = 0;             
	TH0  = (Uchar)(TR0_RELOAD>>8);
	TL0  = (Uchar)TR0_RELOAD;
   	TR0  = 1;
	IE   = 0x82; 								// IE: timer0 82   
//	TH1 = (Uchar)(TR0_RELOAD>>8);
//	TL1 = (Uchar)TR0_RELOAD;
//	TR1=1;
		}

void main(void)
{
	 io_open();
     initlcd();
top: 
	clrlcd();
	 dispstr(" Access System ",0,14);	 
	 delay(10);	 	 
	 dispstr(" Enter Password ",16,31);
	 once=0;
loop:	 if(ready==1) goto loop;
check: if( ok==1)
		{	 
			 if(once==0)
			 {
			 clrlcd();
			 dispstr(" Access System ",0,14);
			 delay(10);
			 dispstr("   Password OK  ",16,31);
			 }
			 once = 1;
		}
	 else if( err==1)
		{	 
			 if(once==0)
			 {
  			 clrlcd(); 	
			 dispstr(" Access System ",0,14);
			 delay(10);
			 dispstr(" Password Error ",16,31);
			 }
			 once = 1;
		}
     if(ready==0) 
	 	goto check;
	 else
	 	goto top;
	
}
